diff --git a/test/unit/daemon/health_signals_test.rb b/test/unit/daemon/health_signals_test.rb
new file mode 100644
index 000000000..3a47f1206
--- /dev/null
+++ b/test/unit/daemon/health_signals_test.rb
@@ -0,0 +1,187 @@
+require "test_helper"
+require "tmpdir"
+require "hive/daemon/health_signals"
+
+# The health-signal fingerprint must be deterministic (stable for unchanged
+# inputs, flips only when a health-relevant input changes) and the per-tick
+# cache must memoize probe results within a tick but recompute after clear.
+class HiveDaemonHealthSignalsTest < Minitest::Test
+  include HiveTestHelper
+
+  def fake_profile(name: :claude, bin: "claude")
+    profile = Object.new
+    profile.define_singleton_method(:name) { name }
+    profile.define_singleton_method(:bin) { bin }
+    profile
+  end
+
+  def cfg
+    {
+      "daemon" => { "enabled" => true, "poll_interval_sec" => 30 },
+      "execute" => { "agent" => "codex" },
+      "plan" => { "agent" => "claude", "skill_by_agent" => { "claude" => "/plan" } }
+    }
+  end
+
+  def env(home: "/home/u")
+    { "HOME" => home, "HIVE_CODEX_BIN" => "/bin/codex", "HIVE_CLAUDE_BIN" => "/bin/claude" }
+  end
+
+  def with_wrapper
+    Dir.mktmpdir do |dir|
+      path = File.join(dir, "wrapper.sh")
+      File.write(path, "#!/bin/sh\n")
+      yield path
+    end
+  end
+
+  def test_fingerprint_is_deterministic_for_unchanged_inputs
+    with_wrapper do |wrapper|
+      first = Hive::Daemon::HealthSignals.fingerprint(
+        cfg: cfg, project_root: nil, profile: fake_profile, wrapper_path: wrapper, env: env
+      )
+      second = Hive::Daemon::HealthSignals.fingerprint(
+        cfg: cfg, project_root: nil, profile: fake_profile, wrapper_path: wrapper, env: env
+      )
+      assert_equal first, second
+    end
+  end
+
+  def test_fingerprint_changes_when_wrapper_mtime_changes
+    with_wrapper do |wrapper|
+      first = Hive::Daemon::HealthSignals.fingerprint(
+        cfg: cfg, project_root: nil, profile: fake_profile, wrapper_path: wrapper, env: env
+      )
+      File.utime(Time.now + 10, Time.now + 10, wrapper)
+      second = Hive::Daemon::HealthSignals.fingerprint(
+        cfg: cfg, project_root: nil, profile: fake_profile, wrapper_path: wrapper, env: env
+      )
+      refute_equal first, second
+    end
+  end
+
+  def test_fingerprint_changes_when_config_slice_changes
+    with_wrapper do |wrapper|
+      first = Hive::Daemon::HealthSignals.fingerprint(
+        cfg: cfg, project_root: nil, profile: fake_profile, wrapper_path: wrapper, env: env
+      )
+      changed = cfg.merge("execute" => { "agent" => "claude" })
+      second = Hive::Daemon::HealthSignals.fingerprint(
+        cfg: changed, project_root: nil, profile: fake_profile, wrapper_path: wrapper, env: env
+      )
+      refute_equal first, second
+    end
+  end
+
+  def test_fingerprint_drops_nil_components
+    # A nil profile and a nil code digest (read failure) must not crash —
+    # they are dropped from the digest rather than hashed.
+    with_replaced_singleton_method(Digest::SHA256, :file, ->(_path) { raise Errno::ENOENT }) do
+      fingerprint = Hive::Daemon::HealthSignals.fingerprint(
+        cfg: cfg, project_root: nil, profile: nil, wrapper_path: "/nope", env: env
+      )
+      refute_nil fingerprint
+      assert_equal 64, fingerprint.length
+    end
+  end
+
+  def test_code_digest_returns_nil_on_read_failure
+    with_replaced_singleton_method(Digest::SHA256, :file, ->(_path) { raise Errno::ENOENT }) do
+      assert_nil Hive::Daemon::HealthSignals.code_digest
+    end
+    refute_nil Hive::Daemon::HealthSignals.code_digest
+  end
+
+  def test_config_slice_handles_missing_daemon_and_stages
+    refute_nil Hive::Daemon::HealthSignals.config_slice({})
+    slice = Hive::Daemon::HealthSignals.config_slice(cfg)
+    assert_includes slice, "/plan"
+    assert_includes slice, "codex"
+  end
+
+  def test_env_slice_includes_configured_keys
+    slice = Hive::Daemon::HealthSignals.env_slice(env)
+    assert_includes slice, "/bin/codex"
+    assert_includes slice, "/bin/claude"
+  end
+
+  def test_codex_login_state_resolution
+    with_replaced_singleton_method(Hive::AgentProfiles, :logged_in?, ->(_name, home: Dir.home) { home == "/home/u" }) do
+      assert_equal "logged-out", Hive::Daemon::HealthSignals.codex_login_state({ "CODEX_HOME" => "/x" })
+      assert_equal "logged-in", Hive::Daemon::HealthSignals.codex_login_state({ "HOME" => "/home/u" })
+      assert_equal "logged-out", Hive::Daemon::HealthSignals.codex_login_state({})
+    end
+  end
+
+  def test_wrapper_state_missing_for_absent_file
+    assert_equal "missing", Hive::Daemon::HealthSignals.wrapper_state("/nonexistent/wrapper.sh")
+    with_wrapper do |wrapper|
+      assert_match(/\d+:\d+/, Hive::Daemon::HealthSignals.wrapper_state(wrapper))
+    end
+  end
+
+  def test_skill_inventory_lists_installed_skill_markers
+    Dir.mktmpdir do |dir|
+      skill_dir = File.join(dir, ".claude", "skills", "ce-work")
+      FileUtils.mkdir_p(skill_dir)
+      File.write(File.join(skill_dir, "SKILL.md"), "# skill\n")
+      inventory = Hive::Daemon::HealthSignals.skill_inventory(dir, env: env(home: dir))
+      assert_includes inventory, "ce-work="
+    end
+  end
+
+  def test_skill_inventory_empty_for_nil_project_root
+    assert_equal "", Hive::Daemon::HealthSignals.skill_inventory(nil, env: env(home: "/nonexistent-home"))
+  end
+
+  def test_profile_state_nil_and_present
+    assert_nil Hive::Daemon::HealthSignals.profile_state(nil)
+    assert_equal "claude:claude", Hive::Daemon::HealthSignals.profile_state(fake_profile)
+  end
+
+  def test_canonical_serialization_is_order_independent
+    assert_equal Hive::Daemon::HealthSignals.canonical({ "b" => 1, "a" => 2 }),
+                 Hive::Daemon::HealthSignals.canonical({ "a" => 2, "b" => 1 })
+    assert_equal "1|2", Hive::Daemon::HealthSignals.canonical([ 1, 2 ])
+    assert_equal "", Hive::Daemon::HealthSignals.canonical(nil)
+    assert_equal "x", Hive::Daemon::HealthSignals.canonical("x")
+  end
+
+  def test_stat_token_rescues_missing_file
+    assert_equal "?", Hive::Daemon::HealthSignals.stat_token("/nonexistent/skill/SKILL.md")
+  end
+
+  # ── cache lifecycle ────────────────────────────────────────────────────
+
+  def test_cache_memoizes_and_recomputes_after_clear
+    cache = Hive::Daemon::HealthSignalCache.new
+    key = [ "implementer_failed", "p" ]
+    assert cache.changed_since_last?(key, "fp-1")
+
+    cache.store(key, fingerprint: "fp-1", results: [ :r1 ])
+    refute cache.changed_since_last?(key, "fp-1")
+    assert_equal({ fingerprint: "fp-1", results: [ :r1 ] }, cache.fetch(key))
+
+    assert cache.changed_since_last?(key, "fp-2"), "a changed fingerprint must re-probe"
+
+    cache.clear
+    assert cache.changed_since_last?(key, "fp-2"), "after clear the next tick must re-probe"
+    assert_nil cache.fetch(key)
+  end
+
+  def test_cache_fingerprint_memoizes_per_key_and_recomputes_after_clear
+    cache = Hive::Daemon::HealthSignalCache.new
+    key = [ "claude_launch_failed", "p" ]
+    calls = 0
+
+    first = cache.fingerprint(key) { calls += 1; "fp-1" }
+    second = cache.fingerprint(key) { calls += 1; "fp-2" }
+    assert_equal "fp-1", first
+    assert_equal "fp-1", second
+    assert_equal 1, calls, "the fingerprint block must run once per key per tick"
+
+    cache.clear
+    assert_equal "fp-3", cache.fingerprint(key) { "fp-3" },
+                 "after clear the next tick recomputes the fingerprint"
+  end
+end
diff --git a/test/unit/daemon/recoverable_signatures_test.rb b/test/unit/daemon/recoverable_signatures_test.rb
new file mode 100644
index 000000000..25de13337
--- /dev/null
+++ b/test/unit/daemon/recoverable_signatures_test.rb
@@ -0,0 +1,140 @@
+require "test_helper"
+require "tmpdir"
+require "hive/daemon/recoverable_signatures"
+require "hive/daemon/status_consumer"
+
+# The diagnostic-signature classifier must admit ONLY the two allowlisted
+# recoverable shapes (Codex-401 implementer_failed + claude_launch_failed)
+# and reject everything else, reading evidence from marker attrs and log
+# tails without ever blocking on non-regular files.
+class HiveDaemonRecoverableSignaturesTest < Minitest::Test
+  include HiveTestHelper
+
+  Signatures = Hive::Daemon::RecoverableSignatures
+  Row = Hive::Daemon::StatusConsumer::Row
+
+  def make_row(marker_attrs:, folder: nil, slug: "s", marker: "error")
+    Row.new(
+      project: "p", slug: slug, stage: "4-execute", workflow: nil,
+      marker: marker, marker_attrs: marker_attrs, folder: folder,
+      state_file: nil, state_file_mtime: nil, action: "error",
+      suggested_command: nil, claude_pid_alive: nil, live_task_lock: false,
+      diagnostic: nil
+    )
+  end
+
+  # ── text predicate ─────────────────────────────────────────────────────
+
+  def test_codex_auth_text_matches_literal_and_401_auth_shapes
+    assert Signatures.codex_auth_text?("codex exec returned 401 Missing bearer/basic auth")
+    assert Signatures.codex_auth_text?("401 Unauthorized: missing bearer token")
+    assert Signatures.codex_auth_text?("error 401 with basic auth required")
+    assert Signatures.codex_auth_text?("MISSING BEARER/BASIC AUTH") # case-insensitive literal
+    assert Signatures.codex_auth_text?("HTTP 401 Bearer token expired")
+    refute Signatures.codex_auth_text?("some 401 error without auth words")
+    refute Signatures.codex_auth_text?("missing bearer token") # no 401
+    refute Signatures.codex_auth_text?("")
+  end
+
+  # ── classification ─────────────────────────────────────────────────────
+
+  def test_classify_codex_auth_from_marker_message
+    row = make_row(marker_attrs: { "reason" => "implementer_failed", "message" => "codex exec returned 401 Missing bearer/basic auth" })
+    assert_equal :codex_auth, Signatures.classify(row)
+  end
+
+  def test_classify_codex_auth_from_log_tail
+    Dir.mktmpdir do |dir|
+      log_dir = File.join(dir, "logs")
+      FileUtils.mkdir_p(log_dir)
+      File.write(File.join(log_dir, "implementer.log"), "codex exec returned 401 missing bearer token\n")
+      row = make_row(marker_attrs: { "reason" => "implementer_failed", "message" => "exit_code=1" }, folder: dir)
+      assert_equal :codex_auth, Signatures.classify(row)
+    end
+  end
+
+  def test_classify_claude_launch_failed
+    row = make_row(marker_attrs: { "reason" => "claude_launch_failed", "message" => "claude interactive prompt did not become ready" })
+    assert_equal :claude_launcher, Signatures.classify(row)
+  end
+
+  def test_classify_rejects_unknown_implementer_failed
+    row = make_row(marker_attrs: { "reason" => "implementer_failed", "message" => "exit_code=1" })
+    assert_nil Signatures.classify(row)
+  end
+
+  def test_classify_rejects_other_reasons
+    row = make_row(marker_attrs: { "reason" => "git_status_failed", "message" => "boom" })
+    assert_nil Signatures.classify(row)
+  end
+
+  def test_codex_auth_failure_and_claude_launch_signature_predicates
+    auth = make_row(marker_attrs: { "reason" => "implementer_failed", "message" => "401 Missing bearer/basic auth" })
+    assert Signatures.codex_auth_failure?(auth)
+    refute Signatures.claude_launch_signature?(auth)
+
+    launch = make_row(marker_attrs: { "reason" => "claude_launch_failed" })
+    assert Signatures.claude_launch_signature?(launch)
+    refute Signatures.codex_auth_failure?(launch)
+  end
+
+  # ── evidence / log tails ───────────────────────────────────────────────
+
+  def test_state_log_tails_reads_global_per_slug_logs
+    Dir.mktmpdir do |dir|
+      state_home = File.join(dir, "state")
+      log_dir = File.join(state_home, "logs", "s")
+      FileUtils.mkdir_p(log_dir)
+      File.write(File.join(log_dir, "run.log"), "401 Missing bearer/basic auth\n")
+      row = make_row(marker_attrs: { "reason" => "implementer_failed" }, slug: "s")
+      tails = Signatures.state_log_tails(row, state_home: state_home)
+      assert_includes tails.join, "401 Missing bearer/basic auth"
+    end
+  end
+
+  def test_state_log_tails_returns_empty_without_slug
+    row = Row.new(
+      project: "p", slug: nil, stage: "4-execute", workflow: nil, marker: "error",
+      marker_attrs: {}, folder: nil, state_file: nil, state_file_mtime: nil,
+      action: "error", suggested_command: nil, claude_pid_alive: nil,
+      live_task_lock: false, diagnostic: nil
+    )
+    assert_equal [], Signatures.state_log_tails(row, state_home: "/tmp/whatever")
+  end
+
+  def test_task_log_tails_returns_empty_without_folder
+    assert_equal [], Signatures.task_log_tails(make_row(marker_attrs: {}))
+  end
+
+  def test_tail_file_skips_non_regular_files
+    Dir.mktmpdir do |dir|
+      regular = File.join(dir, "regular.log")
+      File.write(regular, "hello")
+      assert_includes Signatures.tail_file(regular), "hello"
+
+      # A directory named like a log is not a regular file and must be skipped.
+      dir_as_log = File.join(dir, "dir.log")
+      FileUtils.mkdir_p(dir_as_log)
+      assert_nil Signatures.tail_file(dir_as_log)
+    end
+  end
+
+  def test_marker_attrs_handles_non_hash_and_missing
+    row = make_row(marker_attrs: nil)
+    assert_equal "", Signatures.marker_reason(row)
+    assert_equal "", Signatures.marker_message(row)
+
+    plain = Object.new
+    assert_equal({}, Signatures.marker_attrs(plain))
+  end
+
+  def test_tail_file_rescues_read_failure
+    Dir.mktmpdir do |dir|
+      path = File.join(dir, "regular.log")
+      File.write(path, "hello")
+      with_replaced_singleton_method(Hive::DiagnosticHelpers, :tail_file, ->(_path) { raise Errno::EIO, "boom" }) do
+        assert_nil Signatures.tail_file(path)
+      end
+    end
+  end
+end
